<?php

/**
 * Created by JetBrains PhpStorm.
 * User: paulosoares
 * Date: 23/07/13
 * Time: 18:37
 * To change this template use File | Settings | File Templates.
 */

namespace Planejamento\Logic\Cardapio;

use Geral\Entities\Base\Padraoserv;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util;
use Planejamento\Entities\Base\Confcardpme;
use Planejamento\Entities\Cnfcames;
use Planejamento\Entities\Confcard;
use Planejamento\Entities\Servpadr;
use Planejamento\Logic\Planejamento;
use Setforms2\Shared\Registry;

/**
 * Class ConfiguracaoCardapio
 * @package Planejamento\Logic\Cardapio
 */
class ConfiguracaoCardapio {

    CONST ORIGEM = 'Z';


    // INICIO CNFCAMES


    /*
     * Verifica a data de processamento e maior que a data de refetencia da configuração do cardapio
     */

    public function validaData($data) {
        $data_proc = DateUtil::getMes(\Estoque\Util\Parametros::getDataProcessamento());
        $dt = DateUtil::getMes($data);

        //$diferenca = DateUtil::retornaMaiorData($data, $data_proc);
        //se a data de referencia for maior desabilita os campos e a ação de excluir um campo
        //if ($diferenca == $data_proc) {
        if ($data_proc === $dt) {
           // tk_disable_field('CDTIPOPRAT');
            /*tk_disable_field('DSCOMPLTPMES');
            tk_disable_field('IDOPCCNFMES');
            tk_disable_field('IDCONCNFMES');
            tk_disable_field('CDFILIAL');
            tk_disable_field('CDSERVFILI');
            tk_disable_field('IDATIVO');
            tk_disable_field('IDIMPCNFMES');*/

            tk_set_disable_action('TK_DELETE_ROW_U', 'tab_pla00119');
            //tk_set_disable_action('TK_NEW_ROW_U', 'tab_pla00119');

           // $mensagem = tk_get_message_by_name('msg_pla00119_permitidoApenasAlterarOrdem');
            //return $mensagem;
        }
        return "";
    }

    //busca a ultima ordenação para adicionar um novo prato...
    public static function maxNrseqcnfmes($nrorg, $cdservfili, $dtrefecnfmes, $cdfilial) {
        try {
            /** @var $obj Cnfcames */
            $obj = Cnfcames::getObjectByWhere(
                "NRORG = ? AND CDSERVFILI = ? AND DTREFECNFMES = ?  AND CDFILIAL = ?",
                array($nrorg, $cdservfili, $dtrefecnfmes, $cdfilial),
                "NRSEQCNFMES DESC"
            );
            if (empty($obj)) {
                return 0;
            } else {
                return $obj->getNrseqcnfmes();
            }
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    //Busca o maior valor para um novo prato....
    public static function maxNumeroDeOrdenacao($nrorg, $cdservfili, $dtrefecnfmes, $cdfilial) {
        try {
            /* @var $obj Cnfcames */
            $obj = Cnfcames::getObjectByWhere(
                "NRORG = ? AND CDSERVFILI = ? AND DTREFECNFMES = ? AND CDFILIAL = ? ",
                array($nrorg, $cdservfili, $dtrefecnfmes, $cdfilial),
                "NRORDCNFMES DESC"
            );
            if (empty($obj)) {
                return 0;
            } else {
                return $obj->getNrordcnfmes();
            }
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    //
    public static function atualizaOrdenacao($cdfilial, $cdservfili, $dtrefecnfmes, $destino, $origem,$nrorg) {
        //define a conexao para dar o update no campo NRORDCNFMES
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();

        try {
            if ($origem == self::ORIGEM or $origem == $destino) {
                /** @var $ordenacoes Cnfcames */
                $ordenacoes = Cnfcames::getObjectsByWhere(
                    "NRORG = ? AND CDSERVFILI = ? AND DTREFECNFMES = ? AND NRORDCNFMES >  ?
					AND CDFILIAL = ?",
                    array($nrorg, $cdservfili, $dtrefecnfmes, $destino, $cdfilial)
                );
                /** @var $ordenacao Cnfcames */
                foreach ($ordenacoes as $ordenacao) {
                    $ordenacao->setNrordcnfmes(++$destino);
                    $ordenacao->persist();
                }
            } else if ($origem < $destino) {
                //Se a origem(Numero de ORDENACAO antiga) for maior que a nova ($destino)
                //  busca as oredenações entre $origem e destino e decrementa o valor para  a nova ordenação...
                /** @var $ordenacoes Cnfcames */
                $ordenacoes = Cnfcames::getObjectsByWhere(
                    "NRORG = ? AND CDSERVFILI = ? AND DTREFECNFMES = ? AND NRORDCNFMES <=  ?
					AND CDFILIAL = ?",
                    array($nrorg,$cdservfili, $dtrefecnfmes, $destino, $cdfilial),
                    "NRORDCNFMES DESC"
                );
                //percorre o objeto($obj) decrementando o valor buscado
                /** @var $ordenacao Cnfcames */
                foreach ($ordenacoes as $ordenacao) {
                    $ordenacao->setNrordcnfmes(--$destino);
                    $ordenacao->persist();
                }
            } else if ($origem > $destino) {
                //Se a origem(ordenação antiga) for maior que a de destino(nova ordenação)
                //Busca a ordenação entre $origem e $destino  e incrementa 1 para a nova ordenação
                //Incrementa...
                /** @var $ordenacoes Cnfcames */
                $ordenacoes = Cnfcames::getObjectsByWhere(
                    "NRORG = ? AND CDSERVFILI = ? AND  DTREFECNFMES = ? AND NRORDCNFMES < ?
					AND NRORDCNFMES >= ? AND CDFILIAL = ?",
                    array($nrorg,$cdservfili, $dtrefecnfmes, $origem, $destino, $cdfilial)
                );

                /** @var $ordenacao Cnfcames */
                foreach ($ordenacoes as $ordenacao) {
                    $valor = $ordenacao->getNrordcnfmes();
                    $ordenacao->setNrordcnfmes(++$destino);
                    $ordenacao->persist();
                }
            } else {
                tk_warning($origem.$destino);
            }

            $connection->flush();
            $connection->commit();
            $connection->clear();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    //pega o campo NRORDCNFMES antes de ser atualizado...
    public static function getOrigem($cdservfili, $dtrefecnfmes, $cdfilial, $nrseqcnfmes, $tpPrato,$nrorg) {
        try {
            if (empty($nrseqcnfmes)) {
                $nrseqcnfmes = tk_get_field_value('NRSEQCNFMES');
            }
            /** @var $obj Cnfcames */
            $obj = Cnfcames::getObjectByWhere(
                "NRORG = ? AND CDSERVFILI = ? AND DTREFECNFMES = ? AND CDFILIAL = ? AND NRSEQCNFMES = ?
                AND CDTIPOPRAT = ?",
                array($nrorg,$cdservfili, $dtrefecnfmes, $cdfilial, $nrseqcnfmes, $tpPrato)
            );
            if ($obj == false) {
                return self::ORIGEM;
            } else {
                $retorno = $obj->getNrordcnfmes();
                return $retorno;
            }
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function getDestinoDelete($nrorg, $cdservfili, $dtrefecnfmes, $cdfilial) {
        try {
            /** @var $obj Cnfcames */
            $obj = Cnfcames::getObjectByWhere(
                "NRORG = ? AND CDSERVFILI = ? AND DTREFECNFMES = ? AND CDFILIAL = ?",
                array($nrorg, $cdservfili, $dtrefecnfmes, $cdfilial),
                'NRORDCNFMES DESC');
            if ($obj == false) {
                return self::ORIGEM;
            } else {
                $retorno = $obj->getNrordcnfmes();
                return $retorno;
            }
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }


    // FIM CNFCAMES




    // INICIO CONFCARD


    public static function maxNrseqcnfcard($cdservfili, $nrorg, $cdfilial) {
        try {
            /** @var $obj Confcard */
            $obj = Confcard::getObjectByWhere(
                "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
                array($cdservfili, $nrorg, $cdfilial),
                "NRSEQCNFCARD DESC"
            );

            if ($obj instanceof Confcard) {
                return $obj->getNrseqcnfcard();
            } else {
                return 0;
            }
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }



    public static function salvaConfPadraoCard($nrorg, $filial, $cdTpPrato, $servico, $codigo, $numPagina, $operador){
//        /** @var $obj Confcard */
//        $obj = Confcard::getObjectByWhere(
//            "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ? AND CDTIPOPRAT = ?",
//            array($servico, $nrorg, $filial, $cdTpPrato)
//        );
//
//        if ($obj instanceof Confcard) {
//            return true;
//        } else {
            $con = Registry::getEntityManager();
            $con->beginTransaction();

            try {
                /** @var $ordem \Planejamento\Entities\Confcard*/
                $ordem = Confcard::getUltimaOrdenacao($nrorg, $filial, $servico);

                $conf = new \Planejamento\Entities\Confcard();
                $conf->insereConfPadrao($nrorg, $filial, $codigo, $cdTpPrato, $numPagina, ++$ordem, $servico, $operador);

                $con->flush();
                $con->commit();
            } catch (\Exception $e) {
                $con->rollback();
                throw $e;
            }
//        }
    }


    public static function atualizaNumPagina($nrorg, $filial, $servico){
        /** @var $objs Confcard[] */
        $objs = Confcard::getObjectsByWhere(
            "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
            array($servico, $nrorg, $filial),
            "NRSEQCNFCARD"
        );

        $numPag = 1;
        $aux = 1;

        $con = Registry::getEntityManager();
        $con->beginTransaction();

        try {
            foreach ($objs as $obj) {
                $obj->setNrpagcnfcard($numPag);
                if ($aux === 2) {
                    $numPag++;
                    $aux = 1;
                } else {
                    $aux++;
                }
            }

            $con->flush();
            $con->commit();
        } catch (\Exception $e) {
            $con->rollback();
            throw $e;
        }
    }

    /**
     * Função responsável por atualizar a Ordem da Configuração Padrão do Cardápio
     * O parâmetro $ordemAlterada é um array montado na função
     * salvaTipoPratoConfCard do Facade da TabPla01500000002 (Configuração Padrão).
     * O array é montado da seguinte maneira:
     * 1) Somente elementos que tiveram a Ordenação alterada são salvos nesse array.
     * 2) A chave em que o registro será salvo é a nova ordenação do mesmo.
     * 3) A única informação salva no array é o número da sequência do registro
     * (PK).
     * Se o array não for recebido, significa que não há uma alteração
     * O array novaOrdenacao funciona da seguinte maneira: armazena na posição
     * em que o registro deverá se encontrar, o registro inteiro.
     *
     * @param $nrorg
     * @param $filial
     * @param $servico
     * @param $ordemAlterada
     *
     * @return null
     */
    public static function atualizaOrdemConfPadrao(
        $nrorg, $filial, $servico, $ordemAlterada
    ) {
        $entityManager = \Setforms2\Shared\Registry::getEntityManager();
        $connection = $entityManager->getConnection();
        try {
            $connection->beginTransaction();

            /** @var $confCards Confcard[] */
            $confCards = Confcard::getObjectsByWhere(
                "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
                array($servico, $nrorg, $filial),
                'NRORDCNFCARD'
            );
            //
            if (is_array($ordemAlterada) === true) {
                if (empty($ordemAlterada) === false) {
                    $novaOrdenacao = array();
                    foreach ($ordemAlterada as $ordenacao => $sequencia) {
                        $novaOrdenacao[$ordenacao] = Confcard::getObjectByWhere(
                            "NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ?
                             AND NRSEQCNFCARD = ?",
                            array($nrorg, $filial, $servico, $sequencia)
                        );
                    }
                    $confCard = current($confCards);
                    for ($i = 1; $i <= count($confCards); $i++) {
                        if ($confCard instanceof Confcard === true) {
                            if (in_array($confCard, $novaOrdenacao) === false) {
                                if (empty($novaOrdenacao[$i]) === false) {
                                    $i++;
                                }
                                $novaOrdenacao[$i] = $confCard;
                            } else {
                                $i--;
                            }
                            $confCard = next($confCards);
                        }
                    }
                    //
                    foreach ($novaOrdenacao as $key => $reg) {
                        if ($reg instanceof Confcard === true) {
                            $reg->setNrordcnfcard($key);
                            $reg->persist();
                        }
                    }
                }
            } else {
                $i = 0;
                foreach ($confCards as $confCard) {
                    $i++;
                    $confCard->setNrordcnfcard($i);
                    $confCard->persist();
                }
            }
            //
            $entityManager->flush();
            $connection->commit();
            //
            tk_reload_data_with_filter('tab_pla01500_000_002', 'ger04100');
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            $connection->rollback();
        }
    }


    public static function getOrigemConfPadrao($nrorg, $filial, $cdservfili) {
        try {
            $antigaOrdem = array();

            /** @var $obj Confcard */
            $objs = Confcard::getObjectsByWhere(
                "CDSERVFILI = ? AND NRORG = ? AND CDFILIAL = ?",
                array($cdservfili, $nrorg, $filial)
            );

            if ($objs == false) {
                return self::ORIGEM;
            } else {
                foreach ($objs as $obj) {
                    $antigaOrdem[] = $obj->getNrordcnfcard();
                }
                return $antigaOrdem;
            }
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }


    public static function getUltimaOrdenacao($nrorg, $filial, $servico){
        /** @var $obj \Planejamento\Entities\Confcard */
        $obj = Confcard::getObjectByWhere(
            "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
            array($servico, $nrorg, $filial),
            "NRORDCNFCARD DESC"
        );
        if($obj === false){
            return false;
        }else{
            return $obj->getNrordcnfcard();
        }
    }

    public static function getMaxOrdenacaoPaginaCardapio($nrorg, $filial, $servico)
    {
        try {
            /** @var $obj Confcard */
            $maxNumeroPagina = Confcard::getObjectByWhere(
                "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
                array($servico, $nrorg, $filial),
                "NRPAGCNFCARD DESC"
            );
            if($maxNumeroPagina instanceof Confcard){
                return $maxNumeroPagina->getNrpagcnfcard();
            }
            return 1;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
        }
    }

    public static function getMinOrdenacaoPaginaCardapio($nrorg, $filial, $servico)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();
            /** @var $minNumeroPagina \Planejamento\Entities\Confcard */
            $minNumeroPagina = Confcard::getObjectByWhere(
                "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
                array($servico, $nrorg, $filial),
                "NRPAGCNFCARD ASC"
            );
            return $minNumeroPagina->getNrpagcnfcard();
                //getNrpagcnfcard();
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
        }
    }

    /**
     * Descrição da funçao
     * @static
     * @param string $nrorg            Nrorg
     * @param string $filial           Cdfilial
     * @param string $servico          CdServfili
     * @param int    $nrTiposPorPagina Número de tipos por pagina.
     * @return bool
     */
    public static function ordenacaoNumeroDapaginaCardapio($nrorg, $filial, $servico, $nrTiposPorPagina = 2){
        $connection = \SetForms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try {

            // Ordenação asc para que os registros sejão retornados na ordem dos campos
            //assim o foreach percorre na mesma ordem do valor do campo
            $numerosDePagina = Confcard::getObjectsByWhere(
                "CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
                array($servico, $nrorg, $filial/*, $minPagina, $maxPagina*/),
                "NRPAGCNFCARD ASC"
            );

            $i = $nrTiposPorPagina;
            /** @var $numeroDePagina \Planejamento\Entities\Confcard*/
            foreach ($numerosDePagina as $numeroDePagina) {
                $numeroDePagina->setNrpagcnfcard(floor($i/$nrTiposPorPagina));
                $numeroDePagina->persist();
                $i++;
            }
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            $connection->rollback();
            return false;
        }
    }

    public static function contaNumeroTiposDePratoPaginaCardapio($nrorg, $filial, $servico, $maxPagina){
        /** @var $repositoy \Planejamento\Entities\Confcard */
        $repository = ConfCard::getRepository();
        $numeroDePratos = $repository->contaNumeroDeTipoDeCardapiosNaPagina($nrorg, $filial, $servico, $maxPagina);
        return $numeroDePratos;
    }
    /**
     * deleta a configuração do cardapio
     * @param array $row a linha que deseja ser excluida
     *
      */
    //TODO fix delete is not database persistence
    public static function deletaConfiguracaoCardapio(array $row){
        $con = Registry::getEntityManager();
        $con->beginTransaction();
         try{
             /** @var $configuracaoCardapio \Planejamento\Entities\Confcard*/
             $configuracaoCardapio = Confcard::getObjectByWhere("NRORG = ? AND CDSERVFILI = ? AND
                                                                NRSEQCNFCARD = ? AND CDFILIAL = ?",
                 array($row['NRORG'],$row['CDSERVFILI'],$row['NRSEQCNFCARD'], $row['CDFILIAL'])
             );
             $configuracaoCardapio->delete();
             $con->flush();
             $con->commit();
         } catch(\Exception $e){
             tk_warning($e->getMessage());
             $con->rollback();
         }
    }

    /**
     * Verifica se a tabela padraoserv tem registros
     * @static
     * @param string $nrorg numero da organizacao
     * @return bool|array
     */
    public static function verificaSePadraoServTemRegistros($nrorg){
       try{
           $padroesServ = Servpadr::getObjectsByWhere("NRORG = ?
           ",array($nrorg));
           return $padroesServ;
       }catch (\Exception $e){
           tk_warning($e->getMessage());
           return false;
       }
    }

    public static function salvaTipoPratoConfCard(
        $rowState, $nrorg, $cdfilial, $cdservfili, $cdtipoprat, $nrseqcnfcard,
        $dscompltp, $idopccnfcard, $idimpcnfcard, $dsobscnfcard, $idconcnfcard,
        $operador, $dataAtual
    ) {
        $numPag = 1;
        if ($rowState == 'I') {
            $max = self::maxNrseqcnfcard($cdservfili, $nrorg, $cdfilial);
            self::salvaConfPadraoCard(
                $nrorg, $cdfilial, $cdtipoprat, $cdservfili, ++$max, $numPag, $operador
            );
            self::atualizaNumPagina($nrorg, $cdfilial, $cdservfili);
            //
            $nrseqcnfcard = $max;
        }
        //
        Confcard::atualizaTipoPratoConfCard(
            $nrorg, $cdfilial, $cdservfili, $cdtipoprat, $nrseqcnfcard,
            $dscompltp, $idopccnfcard, $idimpcnfcard, $dsobscnfcard, $idconcnfcard,
            $operador, $dataAtual
        );
    }

    // FIM CONFCARD
}